unit Main;

{
    Author  : Silicoid
    Date    : 14.07.2005
    Version : 2.3
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ShlObj;

type
  TFrmMain = class(TForm)
    edtPkg: TEdit;
    btnUnPack: TButton;
    lblDest: TLabel;
    edtDest: TEdit;
    memDebug: TMemo;
    prgFile: TProgressBar;
    btnPkg: TButton;
    btnDest: TButton;
    dlgOpen: TOpenDialog;
    chkShowAddr: TCheckBox;
    chkNoz: TCheckBox;
    edtZL: TEdit;
    btnZL: TButton;
    rdbPkg: TRadioButton;
    rdbZL: TRadioButton;
    stsInfo: TStatusBar;
    procedure btnUnPackClick(Sender: TObject);
    procedure btnPkgClick(Sender: TObject);
    procedure btnDestClick(Sender: TObject);
    procedure btnZLClick(Sender: TObject);
    procedure rdbPkgClick(Sender: TObject);
    procedure rdbZLClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.dfm}

function OKGF_ZLib_UnCompress2(
  bufUnPack: PChar;
  maxSize: Cardinal;
  bufPack: PChar;
  sizePack:Cardinal
  ):Cardinal;
cdecl; external 'okgf.dll' name 'OKGF_ZLib_UnCompress2';

function OKGF_ZLib_UnCompress(
  bufUnPack: PChar;
  maxSize: Cardinal;
  bufPack: PChar;
  sizePack:Cardinal
  ):Cardinal;
cdecl; external 'okgf.dll' name 'OKGF_ZLib_UnCompress';

var
  pFile: file of byte;
  tFile: file of byte;
  stop : Boolean;

const
  lnRcName = 63;
  lnRcBase = $C;
  lnRcHead = $9E;
  maxBase = 1000;
  maxHead = 100000;

  TYP_UNPACK = 1;
  TYP_PACK = 2;
  TYP_GROUP = 3;

type
  TBaseRecord = record
    UnKnow1: cardinal;
    countRec: cardinal;
    sizeRec: cardinal;
    //--- System ---
    startHead: Integer;
  end;

  THeadRecord = record
    UnKnow1: cardinal;
    TrueSize: cardinal;
    NickName: string[lnRcName];
    FileName: string[lnRcName];
    TypeData: cardinal;
    UnKnow2: cardinal;
    ZeroCheck: cardinal;
    UnKnow3: cardinal;
    offsetFile: cardinal;
    nullTerm: cardinal;
    //--- System ---
    sizePack: cardinal;
  end;

var
  curBase: Integer;
  masBase: array [1..maxBase] of TBaseRecord;
  curHead: Integer;
  masHead: array [1..maxHead] of THeadRecord;

//-------------------------------------

procedure Debug(s:string);
begin
  FrmMain.memDebug.Lines.Add(s)
end;

procedure ReadOneBase();
begin
  curBase:=curBase + 1;
  with masBase[curBase] do
  begin
    BlockRead(pFile, UnKnow1, 4);
    BlockRead(pFile, countRec, 4);
    BlockRead(pFile, sizeRec, 4);
    startHead:=curHead;
  end;
end;

function ReadHeadStr(ln:Integer):string;
var
  s:string;
  buf: array [1..lnRcName] of char;
  i:Integer;
begin
  s:='';
  BlockRead(pFile, buf, ln);
  i:=1;
  while (i<=lnRcName) and (buf[i]<>#0) do
  begin
    s:=s + buf[i];
    i:=i + 1;
  end;
  Result:=s;
end;

procedure ReadOneHead();
begin
  curHead:=curHead + 1;
  with masHead[curHead] do
  begin
    BlockRead(pFile, UnKnow1, 4);
    BlockRead(pFile, TrueSize, 4);
    NickName:=ReadHeadStr(lnRcName);
    FileName:=ReadHeadStr(lnRcName);
    BlockRead(pFile, TypeData, 4);
    BlockRead(pFile, UnKnow2, 4);
    BlockRead(pFile, ZeroCheck, 4);
    BlockRead(pFile, UnKnow3, 4);
    BlockRead(pFile, offsetFile, 4);
    BlockRead(pFile, nullTerm, 4);
    sizePack:=0;
  end;
end;

function GetAddrStr(fPos: Cardinal): String;
begin
  Result:='';
  if FrmMain.chkShowAddr.Checked then
  begin
    Result:=' ['+IntToHex(fPos,8)+']';
  end;
end;

procedure ProcessUnPack(fPos, size:Cardinal; path:string);
var
  buf:Pointer;
  rd:Integer;
begin
  GetMem(buf, size);
  try
    Seek(pFile, fPos+4);
    BlockRead(pFile, buf^, size, rd);
    AssignFile(tFile, path);
    ReWrite(tFile);
    BlockWrite(tFile, buf^, size);
    Closefile(tFile);
    Debug('FILE'+GetAddrStr(fPos+4)+': '+path);
  finally
    FreeMem(buf);
  end;
end;

procedure ProcessPack(fPos, uSize:Cardinal; path:string);
var
  rd:Integer;
  bufPack, bufUnPack: PChar;
  packSize, doneSize, unzSize: Cardinal;
begin
  if FrmMain.chkNoz.Checked and FrmMain.chkNoz.Enabled then
  begin
    //   ZL02
    Seek(pFile, fPos+4);
    BlockRead(pFile, packSize, 4, rd);
    GetMem(bufUnPack, uSize);
    try
      Seek(pFile, fPos+8);
      BlockRead(pFile, bufUnPack^, uSize, rd);
      AssignFile(tFile, path);
      ReWrite(tFile);
      BlockWrite(tFile, bufUnPack^, uSize, rd);
      CloseFile(tFile);
    finally
      FreeMem(bufUnPack);
    end;
    Debug('ZL02'+GetAddrStr(fPos+4)+': '+path);
  end else
  begin
    GetMem(bufUnPack, uSize);
    try
      FrmMain.prgFile.Max:=uSize;
      FrmMain.prgFile.Position:=0;
      //-------------------------
      doneSize:=0; unzSize:=1;
      Seek(pFile, fPos+4);
      while (doneSize<uSize) and (unzSize<>0) and not stop do
      begin
        BlockRead(pFile, packSize, 4, rd);
        GetMem(bufPack, packSize);
        try
          BlockRead(pFile, bufPack^, packSize, rd);
          //   OKGF.DLL
          unzSize:=OKGF_ZLib_UnCompress2(bufUnPack + doneSize, 65536, bufPack, packSize);
          doneSize:=doneSize + unzSize;
        finally
          FreeMem(bufPack);
        end;
        FrmMain.prgFile.Position:=doneSize;
      end;
      FrmMain.prgFile.Position:=0;
      //---------------------------------
      AssignFile(tFile, path);
      ReWrite(tFile);
      BlockWrite(tFile, bufUnPack^, uSize, rd);
      CloseFile(tFile);
      //---------------------------------
      Debug('ZL02'+GetAddrStr(fPos+4)+': '+path);
    finally
      FreeMem(bufUnPack);
    end;
  end;
end;

procedure ReadHeaders(fPos:Cardinal; path:string);
var
  i,psz,cnt: Integer;
  typ, ofs, siz: Cardinal;
  nam:string;
begin
  Debug('GRP '+GetAddrStr(fPos+4)+': '+path);
  ForceDirectories(path);
  Seek(pFile, fPos);
  ReadOneBase();
  psz:=curHead + 1;
  masBase[curBase].startHead:=psz;
  cnt:=masBase[curBase].countRec;
  for i:=1 to cnt do ReadOneHead();
  //----------------------------------
  i:=psz;
  while (i<psz+cnt) and not stop do
  begin
    typ:=masHead[i].TypeData;
    ofs:=masHead[i].offsetFile;
    siz:=masHead[i].TrueSize;
    nam:=path + '\' + masHead[i].NickName;
    FrmMain.stsInfo.SimpleText:=nam;
    if typ=TYP_GROUP then
        ReadHeaders(ofs, nam)
    else if typ=TYP_UNPACK then
        ProcessUnPack(ofs, siz, nam)
    else if typ=TYP_PACK then
        ProcessPack(ofs, siz, nam);
    //---------------------------------
    i:=i+1;
    Application.ProcessMessages;
  end;
  FrmMain.stsInfo.SimpleText:='';
end;

procedure ProcessPackZL(fPos:Cardinal; path,name:string);
const
  uSize = $10000000;
var
  zlType: String;
  rd, i:Integer;
  bufPack, bufUnPack: PChar;
  packSize, unzSize: Cardinal;
begin
  ForceDirectories(path);
  Seek(pFile, fPos);
  GetMem(bufUnPack, uSize);
  try
    packSize:=FileSize(pFile);
    GetMem(bufPack, packSize);
    try
      BlockRead(pFile, bufPack^, packSize, rd);
      zlType:=''; unzSize:=0;
      for i:=0 to 3 do zlType:=zlType+bufPack[i];
      //   OKGF.DLL
      if zlType='ZL01' then
      begin
        unzSize:=OKGF_ZLib_UnCompress(bufUnPack, uSize, bufPack, packSize)
      end else if zlType='ZL02' then
      begin
        unzSize:=OKGF_ZLib_UnCompress2(bufUnPack, uSize, bufPack, packSize);
      end;
    finally
      FreeMem(bufPack);
    end;
    //---------------------------------
    if unzSize<>0 then
    begin
      AssignFile(tFile, path+'\'+name);
      ReWrite(tFile);
      BlockWrite(tFile, bufUnPack^, unzSize, rd);
      CloseFile(tFile);
    end;
    //---------------------------------
    Debug('ZL: '+GetAddrStr(fPos+4)+': '+path+'\'+name);
  finally
    FreeMem(bufUnPack);
  end;
end;

procedure StartRead(path, dest:string);
var
  xPos: Cardinal;
begin
  curHead:=0; curBase:=0;
  AssignFile(pFile, path);
  Reset(pFile);
  BlockRead(pFile, xPos, 4);
  ReadHeaders(xPos, dest);
  CloseFile(pFile);
end;

procedure StartUnZL(path, dest:string);
begin
  curHead:=0; curBase:=0;
  AssignFile(pFile, path); Reset(pFile);
  ProcessPackZL(0, Dest,ExtractFileName(path));
  CloseFile(pFile);
end;

procedure TFrmMain.btnUnPackClick(Sender: TObject);
var
  ret: Integer;
begin
  if stop then
  begin
    stop:=false;
    btnUnPack.Caption:='';
    memDebug.Clear;
    try
      if rdbPkg.Checked then
      begin
        StartRead(edtPkg.Text, edtDest.Text);
      end else
      begin
        StartUnZL(edtZL.Text, edtDest.Text);
      end;
      ShowMessage(' ');
    finally
      btnUnPack.Caption:='';
      stop:=true;
    end;
  end else
  begin
    ret:=Application.MessageBox(' ,   ?','',MB_YESNO);
    if ret=IDYES then stop:=true;
  end;
end;

function GetFolder(Wnd: HWND; Title: String; bifType:Integer): String;
var
  lpItemID: PItemIDList;
  BrowseInfo: TBrowseInfo;
  Buf: array [0..MAX_PATH] of Char;
begin
  Result:='';
  FillChar(BrowseInfo, SizeOf(TBrowseInfo), #0);
  BrowseInfo.hwndOwner:=Wnd;
  BrowseInfo.pszDisplayName:=@Buf;
  BrowseInfo.lpszTitle:=PChar(Title);
  BrowseInfo.ulFlags:=bifType;
  lpItemId:=SHBrowseForFolder(BrowseInfo);
  if lpItemId<>nil then
  begin
    if SHGetPathFromIDList(lpItemId, Buf) then Result:=Buf;
    GlobalFreePtr(lpItemID);
  end;
end;

procedure EnableElemByRadio();
begin
  with FrmMain do
  begin
    edtZL.Enabled :=rdbZL.Checked;
    btnZL.Enabled :=rdbZL.Checked;
    edtPkg.Enabled:=rdbPkg.Checked;
    btnPkg.Enabled:=rdbPkg.Checked;
    chkNoz.Enabled:=rdbPkg.Checked;
  end;
end;

//-----------------------------------------------

procedure TFrmMain.btnPkgClick(Sender: TObject);
begin
  if dlgOpen.Execute then edtPkg.Text:=dlgOpen.FileName;
end;

procedure TFrmMain.btnDestClick(Sender: TObject);
var
  bifType:Integer;
begin
  bifType:=0;
  edtDest.Text:=GetFolder(Application.Handle, ' ', bifType);
end;

procedure TFrmMain.btnZLClick(Sender: TObject);
begin
  if dlgOpen.Execute then edtZL.Text:=dlgOpen.FileName;
end;

procedure TFrmMain.rdbPkgClick(Sender: TObject);
begin
  EnableElemByRadio;
end;

procedure TFrmMain.rdbZLClick(Sender: TObject);
begin
  EnableElemByRadio;
end;

procedure TFrmMain.FormCreate(Sender: TObject);
begin
  stop:=true;
end;

end.
